//<c>   Copyright 1988-2000 by Gerry J. Danen; all rights reserved.

//<t>   Convert CR to CR/LF
//
//      This program converts a file that only contains <cr> characters to one
//      that contains <cr><lf> pairs.
//
//              Usage:  CR2CRLF file_in file_out
//
//      Full pathnames are supported for the filenames.
//
#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V2.21"
#define pgTITL_ "Convert CR to CR/LF"
#define pgCOPR_ "1988"


long    lines = 0 ;
FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN] ;


void    ShowHelp( void )
{
    logon(1);
    printf( "%s converts a file that only contains <cr> characters to one\n"
            "that contains <cr><lf> pairs.\n\n"
            "Usage:  %s file_in file_out\n\n",
            get_global_program_name(), get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    main( int argc, char *argv[] )
{
    int ch ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "wb", YES, YES );

    fprintf( stderr, "%s: reading %s ...", get_global_program_name(), iFile );

    for (;;)
    {
        ch = fgetc( iFh );
        if ( feof(iFh) )
        {
            _fcloseall();
            fprintf( stderr, " %ld lines\n", lines );
            exit( GD_ERROR_NONE );
        }
        fputc( ch, oFh );
        if ( ch == 0x0D )               // = CR
        {
            fputc( 0x0A, oFh );         // write LF
            lines += 1 ;
        }
    }
}
