//<c>   Copyright 1988-2000 by Gerry J. Danen; all rights reserved.

//<t>   Convert CR/LF to LF
//
//      This program converts a file that contains <cr><lf> pairs to one that
//      contains only <lf> characters.  Useful for moving text files from an
//      MS-DOS system to an Amiga.
//
//              Usage:  CRLF2LF file_in file_out
//
//      Full pathnames are supported for the filenames.
//
#include"gd_tools.h"
#include"gd_extrn.h"


#define pgVERS_ "V2.20"
#define pgTITL_ "Convert CR/LF to LF"
#define pgCOPR_ "1988"


UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[10001], *w ;
FILE    *iFh, *oFh ;
long    lines = 0 ;


void    show_help( void )
{
    fprintf( stderr, "\nUsage:  %s file_in file_out\n\n", get_global_program_name() );
    exit( 1 );
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
        show_help();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", iFile );
        show_help();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "wb", YES, YES );

    fprintf( stderr, "%s: reading %s ...", get_global_program_name(), iFile );
    FOREVER
    {
        w = fgets( work, (sizeof(work)-1), iFh );
        if ( w )
        {

            fprintf( oFh, "%s", work );
            lines += 1 ;
            if ( (lines MOD 10) == 0L )
                fprintf( stderr, "\r%ld", lines );
        }
        if ( feof(iFh) )
        {
            _fcloseall();
            fprintf( stderr, "\rConverted %ld lines%c\n", lines, (lines>1000L ? BELL : SPACE) );
            exit( 0 );
        }
    }
}
